<script>
  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];

  // d3-scale
  import { scaleLinear, scaleOrdinal } from 'd3-scale';
  import {schemeDark2} from 'd3-scale-chromatic';
  const scale_x = scaleLinear()
                  .domain([0, 10])
                  .range([0, innerWidth]);
  const scale_y = scaleLinear()
                  .domain([0, 3])
                  .range([innerHeight, 0]);
  const scale_colours = scaleOrdinal(schemeDark2);
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    {#each values as value} 
      <line x1={scale_x(value.x)} y1={scale_y(value.y)} x2={scale_x(value.x)} y2={innerHeight} stroke="black"></line>
      <circle cx={scale_x(value.x)} cy={scale_y(value.y)} r="5" fill={scale_colours(value.category)}></circle>
      <text x={scale_x(value.x)} y={scale_y(value.y)-10} class="valueLabel">{value.y}</text>
    {/each}
    <line x1="0" y1={innerHeight} x2={innerWidth} y2={innerHeight} stroke="black"></line>
  </g>
</svg>

<style>
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>
